PAGE	59,132
TITLE	 TDHack interrupt generator , (c)1994 by MeteO
%DEPTH 0
%LINUM 3
Locals $$
.XLIST
;
;									      
;				     TDHack 		 	     	      
;									      
;	Created: 26.07.94 10:20  					      
;	Version: 1.41.01 (commercial release)				      
;	Copyright (C) 1994 MeteO 					      
;									      
;	MeteO assumes no responsibility on any side-effect in using this code 
;									      
;
.286c
.LIST

$Progname		Equ	'TDHack '
Copyright		Equ     '(x)1994 by MeteO'
$ver$			Equ	'v1.41.00r'
;
Vector_08h_off		Equ	4*08h		;
Vector_08h_seg		Equ	4*08h+2 	;
;
Timer_command_register	Equ	0043h		; port address
Timer_latch_register	Equ	0042h		; port address
Port_pb 		Equ	0061h		; port address
;
Psp_Cmd 		Equ	80h		;
Psp_end         	Equ     5ch
Old_isr08		Equ	Psp_end		; dd previous INT 08h handler
Flag			Equ 	Old_isr08+4     ; Internal wk flag
Speed			Equ 	Flag+1   	; Saved processor MHZ div 100
CPUtype 		Equ	Speed+1		; Heres move proc type
END$PSP			=  	CPUType+2
C$Rel			Equ 	offset Int08handler - END$PSP
;
i8086			Equ	0		; Intel 8086/88
i80286			Equ	1		; Intel 80286
i80386			Equ	2		; Intel 80386
i80486			Equ	3		; Intel 80486
;
Cr			Equ	0dh		;
Lf			Equ	0ah		;
;
COUNT			Equ	5
Sprite			Equ	08Bh,0C6h,0F7h,0F3h ; Mov Ax,Si / Div Bx


TDHack_text	segment byte public 'CODE'
		assume cs:TDHack_text,ds:TDHack_text
		org 100h

;
Start:
		jmp	$boot$
		db	0

m_Herald	db ''
		db $Progname
		db $ver$
		db Copyright ,Cr,Lf,'$'
;
;
;
;			INT 08h Entry Point
;
;
;
;
;
Int08handler:
		cli
		or	byte ptr cs:Flag, 0	; We are already in 08 handler?
		jz	$$2			; yep, proceed
$$1:    	jmp	dword ptr cs:Old_isr08	; go back

$$2:						;
		pusha
		push	ds es

		push	cs
		pop	ds

		cli
		call	mhz
		cmp	ah, byte ptr ds:Speed

		pop	es ds
		popa

		je	$$1
		sti
		pushf
		call	dword ptr cs:Old_isr08

		mov	byte ptr cs:Flag, 1	; Disable Wk of MHZ part
		sti
		int	3  			; Trap to Debugger
		mov	byte ptr cs:Flag, 0     ; Enable Wk of MHZ part

		iret

;
; CPU MHZ meter
;
;		SUBROUTINE MHZ - CPU MHZ measurement
;
;
;
mhz proc					; Speed procedure (Inp: Al=CPU )
		mov	ax, word ptr ds:CPUtype
		push	ax			; Save CPU

		mov	bx, offset ds:Tabl - C$Rel	; Ax:=Tabl[Al]
		xlat
		xchg	cx, ax

		mov	si,07aaah		; Si=07AAAh (Air value)
		mov	bx,05555h		; Bx=05555h (Air value)
	       	xor	dx,dx			; Dx=0

		call	SetTimer
	$$pass:
		db	COUNT dup(Sprite)	; Mov Ax,Si / Div Bx
		loop    $$pass			;
		call	GetTimer		;
		xchg  di, ax			; Save divider

		pop	si                      ; Restore CPU value
		shl	si, 2			; Si:=Si*4

		add	si, offset CPUfix- C$Rel; Si:=CPUFix[si]
		lodsw                           ; Some optimisations :)
		xchg	ax, dx
		lodsw

		div	di			; Ax=Dx:Ax/Di
		mov	dx, di
 $$exit:

		Ret				; Return
mhz endp					; End of Speed procedure
;
;
SetTimer proc near				; SetTimer procedure
		in	al,Port_pb		; Get Al from 61th port
		and	al,0fch			; Zero first bit
		out	Port_pb,al		; Put Al on 61th port
		mov	al,0B4h 		; Al=Command
		out	Timer_command_register,al
		mov	al,0			; Al=0
		out	Timer_latch_register,al	; Put low Time to 42th port
		jcxz    $+2			; Delay for I/O
		out	Timer_latch_register,al	; Put high Time
		in	al,Port_pb		;
		or	al,1			; Set First bit
		cli				; Disable Interrupts
		out     Port_pb,al		; Start Timer
	ret					; Return
SetTimer endp					; End of procedure
;
;
GetTimer proc near				; GetTimer Procedure
		in	al,Timer_latch_register	; Get AL from 42th port
		mov	ah,al			;
		In	al,Timer_latch_register	; Get Al from 42th port
		xchg	al,ah			;
		push	ax
		in	al,Port_pb		; Get al from 61th port
		and	al,0fch			; Zero first bit (stop timer)
		out	Port_pb,al
		pop     ax
		neg	ax
		sti
	ret					; Return
GetTimer endp					; End of GetTimer procedure

;

CPUfix:						; Constants for
		dw      002dh,0bc18h        	; Intel 8088/86
		dw	00c9h,07af8h		; Intel 80286
		dw	0114h,02000h       	; Intel 80386
		dw	00c7h,00000h       	; Intel 80486

Tabl		db	10,150,200
		dw	255

Rld_len 	Equ	$-Int08handler
E$ISR		Equ	$-C$Rel
;
$boot$:
Begin:
		mov	ah, 9
		mov	dx, offset m_Herald
		int	21h

		call	Parms

		xor	ax, ax
		mov	es, ax

		push	word ptr es:Vector_08h_seg	; Save vector 08h
		push	word ptr es:Vector_08h_off      ;
		pop	word ptr cs:Old_isr08		;
		pop	word ptr cs:Old_isr08+2

Keep:
		push	word ptr cs:[2ch]
		pop	es
		mov	ah,49h		; DOS Services  ah=function 49h
		int	21h		; release memory block, es=seg

		push	cs
		pop	es
		mov	cx, Rld_len	; fill unused DTA/Parm area
		mov	si, offset Int08handler
		mov	di, END$PSP
		rep	movsb

		call	processor		; Call processor def. routine
		cmp	byte ptr ds:CPUtype, i80286
		jnl	$$3a			; All operation is available on 286+
		stc
		mov	dx, offset Req286
		jmp	$fatal
	$$3a:
		mov	ax, offset mhz - C$Rel
;;;		call	mhz - C$Rel
		call	ax
		mov	byte ptr ds:Speed, ah
		mov	byte ptr ds:Flag, 0


		mov	ax, 2508h
		mov	dx, offset Int08handler - C$Rel
		int	21h		; DOS -	SET INTERRUPT VECTOR
					; AL = interrupt number
					; DS:DX	= new vector to	be used	for specified interrupt
		mov	ah, 09h
		mov	dx, offset m_Activate
		int	21h

		mov	dx, offset E$ISR
		mov	ax,dx
		shr	dx,4			; Shift w/zeros fill
		test	ax, 0fh
		jz	ts_1
		inc	dx
ts_1:
		mov	ax, 3100h
		int	21h		; DOS -	TERMINATE BUT STAY RESIDENT
					; CS = current program segment
					; DX = last program byte + 1
;
;
;		SUBROUTINE Processor - CPU determine
;
;
;
processor proc 				; Checking for processors
	        xor     ax,ax
        	push    ax
        	popf
        	pushf
        	pop     ax
        	and     ax,0F000h
        	cmp     ax,0F000h
        	je      CPU_8086        ; PSW of 8086 high 4 bits always = 1
        	mov     ax,0F000h
        	push    ax
        	popf
        	pushf
        	pop     ax
        	and     ax,0F000h
        	cmp     ax,0F000h
        	jz      CPU_80286       ;High 4 bits setup to 1
        	jmp     CPU_80386       ;In PSW of 80386 14 bit always = 0

CPU_8086:
		mov	ax,i8086	; AX=i8086
		jmp	short $$exit
CPU_80286:
		mov	ax,i80286	; AX=i80286
		jmp	short $$exit
.386c
CPU_80386:
;;		mov	bx, sp		; save current stack pointer to align it
		and	sp, not	3	; align stack to avoid AC fault
		pushfd			; push original EFLAGS
		pop	eax		; get original EFLAGS
		mov	ecx, eax	; save original EFLAGS
		xor	eax,40000h	; flip AC bit in EFLAGS
		push	eax		; save for EFLAGS
		popfd			; copy to EFLAGS
		pushfd			; push EFLAGS
		pop	eax		; get new EFLAGS value
		xor	eax, ecx	; if AC bit cannot be changed,
		jnz	CPU_80486	; CPU is 386
		mov     ax,i80386 	; AX=i80386
		jmp	short $$exit
CPU_80486:
		mov	ax,i80486	; AX=i80486
	$$exit:
        	mov	word ptr ds:CPUtype,ax
	ret		       		; Return
processor Endp		       		; End Of Processors Procedure
;
$fatal		proc	near
		push    dx cs
		pop	ds
		mov	ah,9		;
		jnc	$$2d
		mov	dx, offset Fatal;
		int	21h		; DOS Services	ah=function 09h
	$$2d:
		pop	dx
		int	21h		; DOS Services	ah=function 09h

	_quit:	mov	ax, 4cffh	; Derminate this program
		int	21h

$fatal		endp
;
		db	Cr,Lf,'L',03,'ve A.K! forever!',Cr,Lf
Help :
		clc
		mov	dx, offset HelpMsg
		jmp	$fatal
;
License:
		clc
		mov	dx, offset LicenseMsg
		jmp	$fatal
;
Unload		proc	near

		mov	byte ptr cs:Flag, 1	; Disable Wk of MHZ part

		mov	ax, 3508h
		int	21h
		push	es

		mov	dx,word ptr es:[Old_isr08]
		push	word ptr es:[Old_isr08+2]
		pop	ds			;
		mov	ax, 2508h		;
		int	21h			;
;
		pop	es			;
		mov	ah, 49h			;
		int	21h			;
;
		clc
		mov	dx, offset Unl
		jmp	$fatal
Unload		endp

;
;
;		SUBROUTINE params
;		parsing command line
;
Parms		proc	near
		cmp	byte ptr ds:Psp_Cmd,0
		jnz	$$1
		retn
;
$$1:		cld
		xor	cx, cx
		mov	cl, byte ptr ds:Psp_Cmd
		mov	al, '/'
		mov	di, Psp_Cmd
Find:		repne	scasb
		jnz	Noslash
		push	ax
		push	bx
		push	cx
		push	di

		mov	al, es:[di]
		cmp	al, 'a'
		jb	$$2
		and	al, 01011111b
$$2:		mov	di, offset Switches
		mov	cx, Sw_len
		repne	scasb
		jnz	Nomatch
		mov	bx, Sw_len
		sub	bx, cx

		and	bx, 0fh

		shl	bx,1
		pop	di
		call	word ptr Sw_tabl[bx]
		pop	cx
		pop	bx
		pop	ax
		jmp	Find
Nomatch:	stc
		mov	dx,offset Bad_parm
		jmp	$fatal
Noslash:	retn
Parms		endp
;
Switches	db	'?HUL'
Sw_len		equ	$-Switches
Sw_tabl		equ	$ - 2
		dw	offset Help
		dw	offset Help
		dw	offset Unload
		dw	offset License
Fatal   	db	$Progname
		db	'-- *FATAL* -- $'
Bad_parm	db	'Error parsing command line.',Cr,Lf,'$'
Req286		db	'286+ reqired..',Cr,Lf,'$'
Unl		db	'Unloaded.$'
HelpMsg		db	'Usage:    '
		db	$Progname
		db	'[/Keys]',Cr,Lf
		db	Cr,Lf,'Command line options:',Cr,Lf
		db	09,'/?, /H - Help',Cr,Lf
		db	09,'/U     - Unload driver',Cr,Lf
		db	Cr,Lf
                db '  Utility for advanced hacking.',Cr,Lf
		db '   It generates INT 03 by pressing <Turbo> key without hooking INT 09',Cr,Lf
		db '   and so is very useful while  hacking  some copy-protected software',Cr,Lf
		db '   that completely steals INT 09. (e.g. games).',Cr,Lf
		db 'Usage:',Cr,Lf
		db ' - run ',$Progname,Cr,Lf
		db ' - run your debugger and the software you will hack',Cr,Lf
		db ' - while running the software press <Turbo> and the debugger',Cr,Lf
		db '   will immediately intercept INT 03 generated by ',$Progname,Cr,Lf
		db ' - reset back <Turbo> key',Cr,Lf
		db ' - trace 3 following commands and after an IRET you will',Cr,Lf
		db '   occur in the broken process.',Cr,Lf,'$'
LicenseMsg	db	'This proggy is written by MeteO. Aug 94 - Oct 94.',Cr,Lf,Cr,Lf
		db	'S/n '
		db	'0000000'
		db	24h
;

m_Activate	db '  To activate press <Turbo>$'
TDHack_text	ends

		end start
